Subject: Re: bug#63271: 29.0.90; broken mouse-face

From: Po Lu <[email-masked]>
Date: Tue, 09 May 2023 20:52:24 +0800

Stephen Berman <[email-masked]> writes:

> On Tue, 09 May 2023 14:50:30 +0300 Eli Zaretskii <[email-masked]> wrote:
>
>>> From: Stephen Berman <[email-masked]>
>>> Cc: [email-masked],  [email-masked],  [email-masked]
>>> Date: Tue, 09 May 2023 12:35:35 +0200
>>>
>>> > OK, thanks.  This is still OK, so please do this with the new
>>> > breakpoint as described in my other email.  It would be interesting to
>>> > see the difference between fundamental-mode and lisp-interaction-mode
>>> > with that second breakpoint.
> [...]
>> This looks OK to me: it says we display 4 characters in one face and 1
>> more in another.  Which agrees with pgrow and with what I understand
>> should happen here: the 4 characters T O D O are displayed using the
>> font of the variable-pitch face, and the blank space after it is
>> displayed using the default face.
>>
>> What do you see on the screen in this case?  Please describe the
>> visual appearance of each character in the case of fundamental-mode,
>> and perhaps also show a screenshot of the window as it is displayed
>> when the mouse-highlight becomes visible during this scenario.
>
> Here's a screenshot of lisp-interaction-mode when the mouse-highlight
> appears:
>
> x
>
>
> And here's one of fundamental-mode:
>
> x
>
>
> Aside from the difference in highlighting, another difference I failed
> to notice before is that in fundamental-mode the string "TODO" is
> displayed with DejaVu Sans but in lisp-interaction-mode with DejaVu Sans
> Mono, although I used the same Lisp code with the face property
> (:inherit variable-pitch) to enter the string in both buffers.  I guess
> lisp-interaction-mode inhibits variable-pitch face and that's the reason
> the mouse-highlighting appears on the problematic characters in that
> mode, in contrast to fundamental-mode.
>
> Steve Berman

What if you change the font driver in use to something else, like X?
i.e.

  (set-frame-parameter (selected-frame) 'font-backend "x")